git.lirion.de

Of git, get, and gud

aboutsummaryrefslogtreecommitdiffstats
path: root/bin/ssh-agent-launcher
blob: 0d116dc944188cf765b4b7fc3b29bbe7b2e1d0e4 (plain) pre { line-height: 125%; } td.linenos .normal { color: inherit; background-color: transparent; padding-left: 5px; padding-right: 5px; } span.linenos { color: inherit; background-color: transparent; padding-left: 5px; padding-right: 5px; } td.linenos .special { color: #000000; background-color: #ffffc0; padding-left: 5px; padding-right: 5px; } span.linenos.special { color: #000000; background-color: #ffffc0; padding-left: 5px; padding-right: 5px; } .highlight .hll { background-color: #ffffcc } .highlight .c { color: #aaaaaa; font-style: italic } /* Comment */ .highlight .err { color: #FF0000; background-color: #FFAAAA } /* Error */ .highlight .k { color: #0000aa } /* Keyword */ .highlight .ch { color: #aaaaaa; font-style: italic } /* Comment.Hashbang */ .highlight .cm { color: #aaaaaa; font-style: italic } /* Comment.Multiline */ .highlight .cp { color: #4c8317 } /* Comment.Preproc */ .highlight .cpf { color: #aaaaaa; font-style: italic } /* Comment.PreprocFile */ .highlight .c1 { color: #aaaaaa; font-style: italic } /* Comment.Single */ .highlight .cs { color: #0000aa; font-style: italic } /* Comment.Special */ .highlight .gd { color: #aa0000 } /* Generic.Deleted */ .highlight .ge { font-style: italic } /* Generic.Emph */ .highlight .ges { font-weight: bold; font-style: italic } /* Generic.EmphStrong */ .highlight .gr { color: #aa0000 } /* Generic.Error */ .highlight .gh { color: #000080; font-weight: bold } /* Generic.Heading */ .highlight .gi { color: #00aa00 } /* Generic.Inserted */ .highlight .go { color: #888
#!/usr/bin/env bash

if [ -z "$SSHENVFILE" ];then
	printf "SSHENVFILE not set, no target for SSH environment variables.\\n" >&2
	exit 1
fi

VERB=1
KILLIT=0
while getopts ":qf" SHOPT;do
	case "$SHOPT" in
		q) VERB=0;;
		f) KILLIT=1;;
		*) printf "WAT\n" >&2;exit 127;;
	esac
done
shift "$(( OPTIND -1 ))"

[ "$VERB" -eq 1 ]&&printf "[....] Starting SSH agent.\\033[s"
ROEDGROED="$(pgrep -U "$(whoami)" ssh-agent|grep -v grep|awk '{print $1}')"

if [ -n "$ROEDGROED" ];then
	if [ "$KILLIT" -eq 1 ];then
		for i in $(echo "$ROEDGROED");do kill "$i" >/dev/null 2>&1||break;done
		case "$?" in
			0);;
			*)
				[ "$VERB" -eq 1 ]&&printf "\\033[666D[\\033[31mFAIL\\033[0m]\\033[u\\033[K\\n"
				exit 2
			;;
		esac
	else
		[ "$VERB" -eq 1 ]&&printf "\\033[666D[\\033[30;1mSKIP\\033[0m]\\033[u\\033[K (running, PID: %s)\\n" "$ROEDGROED"
		exit 0
	fi
fi
ssh-agent >"$SSHENVFILE" 2>&1&&chmod 0600 "$SSHENVFILE" >/dev/null 2>&1
case "$?" in
	0)
		sed -i 's/^echo[^\;]*\;//g' "$SSHENVFILE" >/dev/null 2>&1
		[ "$VERB" -eq 1 ]&&printf "\\033[666D[\\033[32m OK \\033[0m]\\033[u\\033[K\\n"
		exit 0
	;;
	*)
		[ "$VERB" -eq 1 ]&&printf "\\033[666D[\\033[31mFAIL\\033[0m]\\033[u\\033[K\\n"
		exit 1
	;;
esac